#
#	Interface Graphique Perl/Tk pour le projet de C
#			    NoMan
#

# utilise les fichiers "primitives.txt", "historique.txt", "log.txt"
#
# format du fichier 'log.txt' :
#  - un bloc est composee de :
#      - la ligne a interpreter
#      - la taille de la memoire sous la forme : taille_memoire taille (facultatif apres 1 fois)  
#      - les lignes de tas, forme : tas nom_tas adresse_tas taille_tas cpt_ref_tas
#      - une ligne vide ("\n")	
#

use Tk;

$nom_fichier_primitives="primitives.txt";

print("interface : fichier de primitives=$nom_fichier_primitives\n");

$main=MainWindow->new();
$main->title("Systeme de gestion de la memoire et techniques de \"ramasse-miettes\"");
$main->minsize( qw(1010 760) );
$main->maxsize( qw(1010 760) );

$main->Label(text=>"Representation de la memoire :")->pack(-side=>'top', -pady=>5);

$canv=$main->Canvas(-height=>150);
$canv->createRectangle(1,1,990,120, -fill=>'white', -outline=>'black');
$canv->pack(-side=>'top', -fill=>'x', -padx=>5, -pady=>5);

$txttrace=$main->Label(-anchor=>'w', -relief=>'raised', -width=>50, -padx=>5, -pady=>5)->pack(-side=>'top', -pady=>5);

$frame_g=$main->Frame()->pack(-side=>'left', -expand=>'1', -fill=>'both');
$frame_d=$main->Frame()->pack(-side=>'left', -expand=>'1', -fill=>'both');
$frame_g->Label(text=>"Primitives :")->pack(-side=>'top');
$frame_d->Label(text=>"Historique :")->pack(-side=>'top');

$txtprim=$frame_g->Text(-height=>30, -width=>50);
$txtprim->pack(-side=>'left', -expand=>'1', -fill=>'both', -padx=>5, -pady=>10);
$txthist=$frame_d->Text(-height=>30, -width=>50);
$txthist->pack(-side=>'left', -expand=>'1', -fill=>'both', -padx=>5, -pady=>10);

$main->Button(-command=>\&quitter, -text=>"Quitter")->pack(-side=>'bottom', -expand=>'1');
$main->Button(-command=>\&run, -text=>"Tracer")->pack(-side=>'bottom', -expand=>'1');
$main->Button(-command=>\&charge, -text=>"Charger")->pack(-side=>'bottom', -expand=>'1');  

$premiere_charge=1;
&charge;

MainLoop;
  
sub charge {
#
#Remarque : pas besoin de fermer les fichiers because OPEN le fait tout seul...
#
  $txttrace->configure(-text=>"Cliquez sur Trace pour commencer...");

  if ($premiere_charge==1) {
    $premiere_charge=0;
    open(ficprim,$nom_fichier_primitives) or die "Erreur d'acces fichier : $nom_fichier_primitives\n";
    while ($ligne=<ficprim>) {
      $txtprim->insert(end,$ligne);
    }
    close(ficprim);
    open(fichist,"historique.txt") or die "Erreur d'acces fichier : historique.txt\n";
    while ($ligne=<fichist>) {
      $txthist->insert(end,$ligne);
    }
    close(fichist);
  }

  open(fichist,"log.txt") or die "Erreur d'acces fichier : log.txt\n";
  $canv->createRectangle(1,1,990,120, -fill=>'white');
  $premiere_op=0;
};

sub run {
  if ($premiere_op!=0){ &interprete_histo; }
  else { $premiere_op=1; }
  if (!eof(fichist)) {
    $ligne=<fichist>;
    chomp($ligne);
    $txttrace->configure(-text=>$ligne);
  }
  else { $txttrace->configure(-text=>"Fin du fichier !"); }
}

sub interprete_histo {
  $canv->createRectangle(1,1,990,120, -fill=>'white');
  my $pastrouve=1;
  $ligne="bidon";
  while (!eof(fichist) && ($ligne ne "")) {
    $ligne=<fichist>;
    chomp($ligne);
    ($cmd, $arg)=split(/ /,$ligne,2);   
    if ($cmd eq "taille_memoire") { $taillemem=$arg; }
    if ($cmd eq "tas") { &ajoute_zone(split(/ /,$arg)); }
  }  
}

sub ajoute_zone {
  my($nom, $deb, $long)=@_;
  my($x0, $x1);
  $x0=$deb*990/$taillemem+1;
  $x1=($deb+$long)*990/$taillemem+1;
  $canv->createRectangle($x0,1,$x1,120, -fill=>'red');
  $canv->createText($x0,60, -text=>$nom, -anchor=>'w');
  $canv->createText($x0,1, -text=>$deb, -anchor=>'nw');
  $canv->createText($x1,120, -text=>$deb+$long-1, -anchor=>'se');
}  

sub quitter {
  close(fichist);
  print("interface : Bye bye, j'espere que a vous a plu ;-) !\n");
  exit;
};
