/****************************************
 * Sebastien Leriche, Antoine Jacquet   *
 * En-tete du module de gestion memoire *
 * Niveau 1                             *
 ****************************************/

#ifndef _MEMOIRE_
#define _MEMOIRE_

#include <stdio.h>
#define TAILLE_IDENT 20
/* Nombre de caractere maximum des identificateurs */

extern int taille_memoire;
extern int cpt_malloc, cpt_free;
extern FILE *fhistorique;

struct zone_libre
{
   int adresse;
   int taille;
};

struct liste_libre
{
   struct zone_libre bloc;
   struct liste_libre *p_suivant;
};

struct tas_occupe
{
   char ident[TAILLE_IDENT];
   int adresse;
   int taille;
};

struct liste_tas
{
   struct tas_occupe tas;
   struct liste_tas *p_suivant;
};

int initialiser(struct liste_libre **pp_liste_libre, struct liste_tas **pp_liste_tas);
/* Initialise les differentes listes
   Retourne -1 en cas d'erreur, 0 sinon */

int terminer(struct liste_libre **pp_liste_libre, struct liste_tas **pp_liste_tas);
/* Libere correctement la memoire
   Retourne -1 en cas de mauvaise gestion de la memoire, 0 sinon */

int allouer(int t, struct liste_libre **pp_liste_libre);
/* Alloue une zone memoire de taille t
   Retourne son adresse, -1 sinon */

int liberer(int adresse_libre, int taille_libre, struct liste_libre **pp_liste_libre);
/* Libere la zone memoire de taille taille_libre a l'adresse adresse_libre
   Retourne -1 en cas d'erreur, 0 sinon */

int allouer_tas(char identite_tas[], int taille_tas, struct liste_libre **pp_liste_libre, struct liste_tas **pp_liste_tas);
/* Ajoute un tas de nom identite_tas et de taille taille_tas
   Retourne -1 en cas d'erreur, 0 sinon */

int liberer_tas(char identite_tas[], struct liste_libre **pp_liste_libre, struct liste_tas **pp_liste_tas);
/* Libere le tas de nom identite_tas
   Retourne -1 en cas d'erreur, 0 sinon */

#endif
